<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLinhasComprasStatusERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLinhasComprasStatusERP
 * @subpackage Arrays
 */
class ArrayOfLinhasComprasStatusERP extends AbstractStructArrayBase
{
    /**
     * The LinhasComprasStatusERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LinhasComprasStatusERP[]
     */
    public $LinhasComprasStatusERP;
    /**
     * Constructor method for ArrayOfLinhasComprasStatusERP
     * @uses ArrayOfLinhasComprasStatusERP::setLinhasComprasStatusERP()
     * @param \StructType\LinhasComprasStatusERP[] $linhasComprasStatusERP
     */
    public function __construct(array $linhasComprasStatusERP = array())
    {
        $this
            ->setLinhasComprasStatusERP($linhasComprasStatusERP);
    }
    /**
     * Get LinhasComprasStatusERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LinhasComprasStatusERP[]|null
     */
    public function getLinhasComprasStatusERP()
    {
        return isset($this->LinhasComprasStatusERP) ? $this->LinhasComprasStatusERP : null;
    }
    /**
     * Set LinhasComprasStatusERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasComprasStatusERP[] $linhasComprasStatusERP
     * @return \ArrayType\ArrayOfLinhasComprasStatusERP
     */
    public function setLinhasComprasStatusERP(array $linhasComprasStatusERP = array())
    {
        foreach ($linhasComprasStatusERP as $arrayOfLinhasComprasStatusERPLinhasComprasStatusERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfLinhasComprasStatusERPLinhasComprasStatusERPItem instanceof \StructType\LinhasComprasStatusERP) {
                throw new \InvalidArgumentException(sprintf('The LinhasComprasStatusERP property can only contain items of \StructType\LinhasComprasStatusERP, "%s" given', is_object($arrayOfLinhasComprasStatusERPLinhasComprasStatusERPItem) ? get_class($arrayOfLinhasComprasStatusERPLinhasComprasStatusERPItem) : gettype($arrayOfLinhasComprasStatusERPLinhasComprasStatusERPItem)), __LINE__);
            }
        }
        if (is_null($linhasComprasStatusERP) || (is_array($linhasComprasStatusERP) && empty($linhasComprasStatusERP))) {
            unset($this->LinhasComprasStatusERP);
        } else {
            $this->LinhasComprasStatusERP = $linhasComprasStatusERP;
        }
        return $this;
    }
    /**
     * Add item to LinhasComprasStatusERP value
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasComprasStatusERP $item
     * @return \ArrayType\ArrayOfLinhasComprasStatusERP
     */
    public function addToLinhasComprasStatusERP(\StructType\LinhasComprasStatusERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LinhasComprasStatusERP) {
            throw new \InvalidArgumentException(sprintf('The LinhasComprasStatusERP property can only contain items of \StructType\LinhasComprasStatusERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LinhasComprasStatusERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LinhasComprasStatusERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LinhasComprasStatusERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LinhasComprasStatusERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LinhasComprasStatusERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LinhasComprasStatusERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LinhasComprasStatusERP
     */
    public function getAttributeName()
    {
        return 'LinhasComprasStatusERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLinhasComprasStatusERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
